"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var html_webpack_plugin_1 = tslib_1.__importDefault(require("html-webpack-plugin"));
var copy_webpack_plugin_1 = tslib_1.__importDefault(require("copy-webpack-plugin"));
var plugins_1 = require("./plugins");
var util_1 = require("./util");
function mwMultiEntryHTML(context, next) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var packageMap, plugins, ENV, __IS_BUILD_LIBRARY__, version, versionTail;
        return tslib_1.__generator(this, function (_a) {
            next();
            packageMap = context.packageMap, plugins = context.plugins, ENV = context.ENV, __IS_BUILD_LIBRARY__ = context.__IS_BUILD_LIBRARY__;
            if (__IS_BUILD_LIBRARY__ === true) {
                return [2];
            }
            plugins.push(new copy_webpack_plugin_1.default(util_1.getBuildCopyFiles(context.files)));
            context.externals = util_1.getBuildExternals(tslib_1.__assign({}, context.files, context.externals));
            version = context.version || packageMap.version || '0.0.0';
            versionTail = ENV.isBeta ? '-beta' : ENV.isDevelopment ? '-dev' : '';
            plugins.push(new plugins_1.DefinePlugin(tslib_1.__assign({ VERSION: JSON.stringify(version), APPLICATION_VERSION: JSON.stringify("v" + version + versionTail) }, context.defines)), new plugins_1.ProvidePlugin(context.provides));
            util_1.getBuildHTML(context).forEach(function (line) { return plugins.push(new html_webpack_plugin_1.default(line)); });
            return [2];
        });
    });
}
exports.default = mwMultiEntryHTML;
